﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataRequest
{
    public partial class Debug_Console : Form
    {
        public Debug_Console()
        {
            InitializeComponent();
        }
        private delegate void StringSend(object label, String str);
        private delegate void ByteSend(object label, byte[] data);
        private delegate void CharSend(object label, char[] data);
        private delegate int StringLineLength(object label);
        private delegate int StringGetFirstCharIndexFromLine(object label,int Length,int MaxLength);
        private void Byte_Set(object label, byte[] data)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            for (int i = 0; i < data.Length; i++)
            {
                Temp_label.Text += Convert.ToString(data[i], 16);
                Temp_label.Text += "";
            }
        }
        private void Char_Set(object label, char[] data)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            for (int i = 0; i < data.Length; i++)
                Temp_label.Text += data[i].ToString();
        }
        private void TextBox_Text_Set(object label, String str)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            Temp_label.Text = str;
        }
        private void TextBox_Text_Append(object label, String str)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            Temp_label.AppendText(str);
        }
        private void TextBox_Text_SelectedText(object label, String str)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            Temp_label.SelectedText = (str);
        }
        private int TextBox_Text_Lines_Length(object label)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            return Temp_label.Lines.Length;
        }
        private int TextBox_Text_GetFirstCharIndexFromLine(object label, int Length, int MaxLength)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            return Temp_label.GetFirstCharIndexFromLine(Length - MaxLength);
        }
        private int TextBox_Text_Select(object label,int start,int Length)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            Temp_label.Select(start,Length);
            return 0;
        }
        private int TextBox_Text(object label)
        {
            RichTextBox Temp_label = (RichTextBox)label;
            Temp_label.ScrollToCaret();
            return 0;
        }
#if false
        public void RecvData(string str)
        {
            this.Invoke(new StringSend(TextBox_Text_Set), richTextBox_Debug,str); 
            //richTextBox_Debug.Text = str;

        }
#else

        public void RecvData(string text)
        {
 
            int Length = (int)this.Invoke(new StringLineLength(TextBox_Text_Lines_Length), richTextBox_Debug);
            int maxline = 10000;
            int GetFirstCharIndexFromLine_Length = (int)this.Invoke(new StringGetFirstCharIndexFromLine(TextBox_Text_GetFirstCharIndexFromLine), richTextBox_Debug, maxline, Length );
            if (Length > maxline)
            {
                this.Invoke(new StringGetFirstCharIndexFromLine(TextBox_Text_Select), 0, GetFirstCharIndexFromLine_Length);
                this.Invoke(new StringSend(TextBox_Text_SelectedText), richTextBox_Debug, "");
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, "\n");
            }
            else
            {
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, "\n");
            }
            // richTextBox_Debug.ScrollToCaret();
            this.Invoke(new StringLineLength(TextBox_Text), richTextBox_Debug);
            if (aSCIIToolStripMenuItem.Checked == true)
            {
                this.Invoke(new CharSend(Char_Set), richTextBox_Debug, text.ToArray());
            }
            else
            {
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, text);
            }
            /****
              *메모리 누수 방지용 코드
              */
            System.GC.Collect(0, GCCollectionMode.Forced);
            System.GC.WaitForFullGCComplete();

        }
        public void RecvData(byte[] text)
        {

            int Length = (int)this.Invoke(new StringLineLength(TextBox_Text_Lines_Length), richTextBox_Debug);
            int maxline = 10000;
            int GetFirstCharIndexFromLine_Length = (int)this.Invoke(new StringGetFirstCharIndexFromLine(TextBox_Text_GetFirstCharIndexFromLine), richTextBox_Debug, maxline, Length);
            if (Length > maxline)
            {
                this.Invoke(new StringGetFirstCharIndexFromLine(TextBox_Text_Select), 0, GetFirstCharIndexFromLine_Length);
                this.Invoke(new StringSend(TextBox_Text_SelectedText), richTextBox_Debug, "");
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, "\n");
            }
            else
            {
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, "\n");
            }
            // richTextBox_Debug.ScrollToCaret();
            this.Invoke(new StringLineLength(TextBox_Text), richTextBox_Debug);
            if (aSCIIToolStripMenuItem.Checked == true)
            {
                this.Invoke(new ByteSend(Byte_Set), richTextBox_Debug, text);
            }
            else
            {
                this.Invoke(new StringSend(TextBox_Text_Append), richTextBox_Debug, text);
            }
            /****
              *메모리 누수 방지용 코드
              */
            System.GC.Collect(0, GCCollectionMode.Forced);
            System.GC.WaitForFullGCComplete();

        }
        private void aSCIIToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void consolClearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Invoke(new StringSend(TextBox_Text_Set), richTextBox_Debug, "");
        }

#endif
    }
}
