﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataRequest.Func
{
    public class Serial
    {
        public Form main_form;
        
        private System.IO.Ports.SerialPort serialPort;
        private Debug Debug = new Debug();    // Teminal Text Wnd Open
        //private Debug_Console debug_Console = new Debug_Console();    // Teminal Text Wnd Open
        public string Serial_Name { get => serialPort.PortName; set => serialPort.PortName = value; }
        public Thread reader, writer;    // 시리얼을 통해서 데이터를 읽고, 쓸 스레드 준비
        Etc_Function etc_Function = new Etc_Function();

        public void SetPortNameValues(object obj)
        {

            string[] ports = SerialPort.GetPortNames(); // load all name of com ports to string
            try
            {
                ((ComboBox)obj).Items.Clear(); //delete previous names in combobox items
            }
            catch { }


            ((ComboBox)obj).DataSource = null;
            foreach (string port in ports) //add this names to comboboxPort items
            {
                ((ComboBox)obj).Items.Add(port); //if there are some com ports ,select first
            }
            if (((ComboBox)obj).Items.Count > 0)
            {
                ((ComboBox)obj).SelectedIndex = 0;
            }
            else
            {
                ((ComboBox)obj).Text = " "; //if there are no com ports ,write Empty
            }
        }

        public void Serial_Port_name_Set(ref ComboBox cb_port)
        {
            serialPort.PortName = Serial_Name = cb_port.SelectedItem.ToString();
        }

        public void Serial_Initialize(ref ComboBox cb_port, string baudrate)
        {
            int BaudRate = Convert.ToInt32(baudrate);
            this.serialPort = new System.IO.Ports.SerialPort();
           // this.serialPort.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.Serial_DataRecvFunction);

            cb_port.BeginUpdate();
            foreach (string comport in SerialPort.GetPortNames())//foreach (string comport in SerialPort_TestProgram.GetPortNames())
            {
                cb_port.Items.Add(comport);
            }
            cb_port.EndUpdate();
            //SerialPort 초기 설정.
            //  serialPort.Encoding = Encoding.GetEncoding("Windows-1252");

            cb_port.DataSource = SerialPort.GetPortNames();
            try
            {
                serialPort.PortName = Serial_Name = cb_port.SelectedItem.ToString();
                serialPort.BaudRate = (int)BaudRate;
                serialPort.DataBits = (int)8;
                serialPort.Parity = System.IO.Ports.Parity.None;
                serialPort.StopBits = StopBits.One;
            }
            catch { }

        }

        public void Start()
        {
            reader = new Thread(new ThreadStart(Read));    // Read()를 수행하는 스레드 reader 생성
            reader.IsBackground = true;    // read는 백그라운드에서 수행하고,
            reader.Start();  // reader 스레드를 실행
//            writer = new Thread(new ThreadStart(Write));    // Write()를 수행하는 스레드 writer 생성
//            writer.Start();    // write는 실제적으로 콘솔창에 입력해야 하므로 foreground로 수행하게 합니다.
        }
        public void Stop()
        {
            //reader = new Thread(new ThreadStart(Read));    // Read()를 수행하는 스레드 reader 생성
            //reader.IsBackground = true;    // read는 백그라운드에서 수행하고,
            reader.Interrupt();
            reader.Abort(); //정지
                           //reader.Join(); //정지
                           //reader.Abort();  // reader 스레드를 실행
                           //            writer = new Thread(new ThreadStart(Write));    // Write()를 수행하는 스레드 writer 생성
                           //            writer.Start();    // write는 실제적으로 콘솔창에 입력해야 하므로 foreground로 수행하게 합니다.
        }
        // Writer thread for Serial port
        public void Write()
        {
            for (;;)
            {
                serialPort.WriteLine(Console.ReadLine());  // 계속 반복하면서 입력된 데이터가 있으면 열려잇는 포트로 데이터 전송
                Thread.Sleep(200);    // 200ms마다 스레드를 잠재워서 다른 스레드가 수행가능하게 합니다.(요건 스레드 프로그래밍을 해보셨으면 아시리라 생각...=_=
            }
        }
        public void Serial_DataSend(byte[] buffer,int Length)
        {
            if(serialPort.IsOpen == true)
                serialPort.Write(buffer, 0, Length);
        }
        private void NessLab_OperateList(byte[] data)
        {
            switch (data[(int)Etc_Function.NessLab_Protocol_Index.NessLab_MsgID0])
            {
                case (int)Etc_Function.NessLab_Protocol_CMD_Index.NessLab_STATUS_RES:
                    ((Main)main_form).subMain.NessLab_Adc_Value_Set(data[7] << 8 | data[8],data[9],data[16]);
                    break;
                case (int)Etc_Function.NessLab_Protocol_CMD_Index.NessLab_TableSet_Res:
                    ((Main)main_form).table.Table_Setting(data);
                    break;
                case (int)Etc_Function.NessLab_Protocol_CMD_Index.NessLab_Table_Res:
                    ((Main)main_form).table.Table_Setting(data);
                    break;
                    
            }

        }
        // Reader thread for Serial port
#if true
        public void Read()
        {
            for (;;)
            {
                int nLnegth = serialPort.BytesToRead;
                byte[] btdata = new byte[nLnegth];
                serialPort.Read(btdata, 0, nLnegth);
                string data2 = serialPort.ReadExisting();
               

                if (nLnegth != 0)
                {
                    string str = Encoding.Default.GetString(btdata);

                    // ((Main)main_form).table.Table_Setting(btdata);
                    try
                    {
                        NessLab_OperateList(btdata);
                        //((Main)main_form).subMain.NessLab_Adc_Value_Set(btdata[7] << 8 | btdata[8]);
                        if (etc_Function.OverLap_Window_Find("Debug_Console") == false)
                        {
                            string data = Encoding.Default.GetString(btdata);
                            if (((Main)(this.main_form)).debug.debug_Console.aSCIIToolStripMenuItem.Checked == true)
                            {
                                ((Main)(this.main_form)).debug.debug_Console.RecvData(btdata);
                            }
                            else
                            {
                                ((Main)(this.main_form)).debug.debug_Console.RecvData(Str2hex(data, true));
                            }
                            //main_form.debug.debug_Console.RecvData(data);
                        }
                    }catch{ }
                    

                        //serialPort.Write(data);    // 열려있는 포트에서 데이터가 존재하면 읽어봐서 콘솔창에 뿌립니다.
                }
                Thread.Sleep(100);    // 위와 마찬가지 이유로 sleep시킴
            }
        }
#else
        public void Read()
        {
            for (; ; )
            {
               
                string data2 = serialPort.ReadExisting();


                if (data2.Length != 0)
                {
                   // string str = Encoding.Default.GetString(btdata);
                    ((Main)(this.main_form)).debug.debug_Console.RecvData(Str2hex(data2, true));


                    //serialPort.Write(data);    // 열려있는 포트에서 데이터가 존재하면 읽어봐서 콘솔창에 뿌립니다.
                }
                Thread.Sleep(100);    // 위와 마찬가지 이유로 sleep시킴
            }
        }
#endif
        public void Serial_Setting(string baudrate)
        {
            int BaudRate = Convert.ToInt32(baudrate);
            this.serialPort = new System.IO.Ports.SerialPort();
            //this.serialPort.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.Serial_DataRecvFunction);
            //SerialPort 초기 설정.
            //  serialPort.Encoding = Encoding.GetEncoding("Windows-1252");
            try
            {
                serialPort.BaudRate = (int)BaudRate;
                serialPort.DataBits = (int)8;
                serialPort.Parity = System.IO.Ports.Parity.None;
                serialPort.StopBits = StopBits.One;
            }
            catch { }

        }
        private delegate void StringSend(string Text);
        private delegate void ByteSend(byte[] Text);

        public string Str2hex(string strData, Boolean Compotable)
        {
            string resultHex = string.Empty;
            //byte[] arr_byteStr = Encoding.Default.GetBytes(strData);
            //byte[] arr_byteStr = Encoding.ASCII.GetBytes(strData);
            byte[] arr_byteStr = System.Text.ASCIIEncoding.ASCII.GetBytes(strData);
            foreach (byte byteStr in arr_byteStr)
            {
                if (Compotable == true)
                    resultHex += string.Format("{0:X2}", byteStr) + " ";
                else
                    resultHex += string.Format("{0:X2}", byteStr);
            }

            return resultHex;
        }

        static public byte[] Str2bytes(string byteData)
        {

#if false
            System.Text.ASCIIEncoding asencoding = new System.Text.ASCIIEncoding();
            return Encoding.Default.GetBytes(byteData);
#else
            byte[] arr_byteStr = Encoding.Default.GetBytes(byteData);
            return arr_byteStr;
#endif
        }
        private delegate void BoolSet();
       
        public byte Serial_PortOpen(ref Button Btn_Portonoff, ref ComboBox cb,string baudrate)
        {
            byte ret = 0;
            try
            {
                if (serialPort.IsOpen)
                { //When the port is open
                    serialPort.Close();
                    Btn_Portonoff.Text = "Connect";
                    Stop();
                    ret = 1;
                    
                }
                else//When the port is close
                {
                    if (cb.Text != "")
                    {
                        //this.main_form.Invoke(new BoolSet(this.main_form.Serial_PortName_get));
                        Serial_Setting(baudrate);
                        serialPort.PortName = cb.Text;
                        serialPort.Open();
                        Btn_Portonoff.Text = "Disconnect";
                        Start();
                        //Debug.Debug_Main_Form_Get(this.main_form);
                    }
                    else
                    {
                        MessageBox.Show("Port is not set");
                        ret = 1;
                    }
                }

            }
            catch
            {
                MessageBox.Show("already port open " + Serial_Name);
                ret = 2;
            }
            return ret;
        }



    }
}
