﻿using DataRequest.Func;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataRequest
{
    public partial class Main : Form
    {
        public Form main_form = null;
        public Serial serial = new Serial();
        public Table table = null;
        public SubMain subMain = null;
        public int TimerIntervalCnt = 0;

        private Form activeForm = null;
        private Etc_Function etc_Function = new Etc_Function();
        private byte[] protocol = null;
        private int TimerInterVal = 0;

        public Main()
        {
            InitializeComponent();
        }


        private void openChildForm(Form childForm)
        {
            if (activeForm != null)
                activeForm.Close();

            activeForm = childForm;
            childForm.TopLevel = false;
            childForm.FormBorderStyle = FormBorderStyle.None;
            childForm.Dock = DockStyle.Fill;
            panel_ChildForm.Controls.Add(childForm);
            panel_ChildForm.Tag = childForm;
            childForm.BringToFront();
            childForm.Show();


        }
        
        private void button_Table_Click(object sender, EventArgs e)
        {
            openChildForm(table = new Table());
            table.main_form = this;
        }

        private void button_Main_Click(object sender, EventArgs e)
        {
            openChildForm(subMain = new SubMain());
        }

        private void Main_Load(object sender, EventArgs e)
        {
            serial.main_form = this;
            serial.Serial_Initialize(ref comboBox_Port, comboBox_Baudrate.Text);
        }

        private void button_SerialConnect_Click(object sender, EventArgs e)
        {
            byte ret = 0;
            ret = serial.Serial_PortOpen(ref button_SerialConnect,ref comboBox_Port, comboBox_Baudrate.Text);
            if (ret == 0) {
               // serial.Start();
                timer1.Start();
            }
            else
            {
                timer1.Stop();
            }

            
        }

        public Debug debug = null;// new Debug();
        private void button_Console_Click(object sender, EventArgs e)
        {
            // Debug debug = new Debug();
            if (etc_Function.OverLap_Window_Find("Debug") == false)
                return;
            else
            {
                debug = new Debug();
                debug.Show();
            }
       
        }
        /*
         Interval 100ms Timer cnt
             */
        private void timer1_Tick(object sender, EventArgs e)
        {
            TimerIntervalCnt++;
            if((TimerInterVal/ 100) <= TimerIntervalCnt)
            {
                if(protocol != null)
                {
                    serial.Serial_DataSend(protocol, protocol.Length);
                }
                TimerIntervalCnt = 0;
            }

        }
        Serial_Config serial_Config = null;
        private void button_Serial_Click(object sender, EventArgs e)
        {
            openChildForm(serial_Config = new Serial_Config());
            serial_Config.main_form = this;
        // serial_Config.Owner = this;
    }

        public void Protocol_DataSetting(byte[] data)
        {
            protocol = data;
        }

        public void Protocol_TimerIntervalSet(int setval)
        {
            TimerInterVal = setval;
        }
        
    }
}
