﻿using DataRequest.Func;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Excel = Microsoft.Office.Interop.Excel;

namespace DataRequest
{
    public partial class Table : Form
    {
        public Form main_form;

        enum NessLab_Index
        {
            NessLab_Header0 = 0,
            NessLab_Header1,
            NessLab_MsgID0,
            NessLab_MsgSN0,
            NessLab_MsgSN1,
            NessLab_Reserve0,
            NessLab_DataLength,
        };



        public Table()
        {
            InitializeComponent();
        }

        private void button_Set_Click(object sender, EventArgs e)
        {

        }

        private void button_ExcelSave_Click(object sender, EventArgs e)
        {
            GridViewExcel(this.dataGridView_TableSetting);
           // button_ExcelKill_Click(null, null);
        }
        const string Filename = "NessLab";
        private void button_ExcelLoad_Click(object sender, EventArgs e)
        {
            string path = Application.StartupPath + "\\" + Filename + ".xls";
            ReadExcelData(path);
        }
        public void GridViewExcel(DataGridView grid)
        {
            Excel.Application oXL;
            Excel._Workbook oWB;
            Excel._Worksheet oSheet;
            //Excel.Range oRng;
            object missingType = Type.Missing;

            this.saveFileDialog1.FileName = Application.StartupPath + "\\" + Filename;
            this.saveFileDialog1.DefaultExt = "xls";
            this.saveFileDialog1.Filter = "Excel files (*.xls)|*.xls";
            this.saveFileDialog1.InitialDirectory = "{Desktop}";
            //DialogResult result = saveFileDialog1.ShowDialog();
            //if (result == DialogResult.OK)
            {
                try
                {
                    //Start Excel and get Application object.
                    oXL = new Excel.Application();
                    oXL.Visible = false;

                    //Get a new workbook.
                    oWB = (Excel._Workbook)(oXL.Workbooks.Add(Missing.Value));
                    //oWB = (Excel._Workbook)(oXL.Workbooks.Add(Missing.Value));
                    oSheet = (Excel._Worksheet)oWB.ActiveSheet;
                    //oSheet = oWB.Worksheets.get_Item(1) as Excel.Worksheet;
                    //oSheet = (Excel.Worksheet)oWB.Worksheets.Item[2] as Excel._Worksheet;

                    //oWB.Worksheets.Item[1] as Excel._Worksheet;

                    //Add table headers going cell by cell.
                    int k = 0;
                    string[] colHeader = new string[grid.ColumnCount];
                    for (int i = 0; i < grid.Columns.Count; i++)
                    {
                        oSheet.Cells[1, i + 1] = grid.Columns[i].HeaderText;

                        k = i + 65;
                        colHeader[i] = Convert.ToString((char)k);
                    }
                    //Format A1:D1 as bold, vertical alignment = center.
                    oSheet.get_Range("A1", colHeader[colHeader.Length - 1] + "1").Font.Bold = true;
                    oSheet.get_Range("A1", colHeader[colHeader.Length - 1] + "1").VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;

                    // Create an array to multiple values at once.
                    object[,] saNames = new object[grid.RowCount, grid.ColumnCount];

                    string tp;
                    for (int i = 0; i < grid.RowCount; i++)
                    {
                        for (int j = 0; j < grid.ColumnCount; j++)
                        {
                            tp = grid.Rows[i].Cells[j].ValueType.Name;
                            if (tp == "String") //2000-01-01 형태의 날짜 필터하기 위함(숫자로 변환 방지)
                                saNames[i, j] = "'" + grid.Rows[i].Cells[j].Value.ToString();
                            else
                                saNames[i, j] = grid.Rows[i].Cells[j].Value;
                        }
                    }

                    //Fill A2:B6 with an array of values (First and Last Names).
                    //oSheet.get_Range("A2", "B6").Value2 = saNames;
                    oSheet.get_Range(colHeader[0] + "2", colHeader[colHeader.Length - 1] + (grid.RowCount + 1)).Value2 = saNames;

                    oXL.Visible = false;
                    oXL.UserControl = false;
                    oWB.SaveAs(saveFileDialog1.FileName,
                    Microsoft.Office.Interop.Excel.XlFileFormat.xlWorkbookNormal,
                    missingType, missingType, missingType, missingType,
                    Microsoft.Office.Interop.Excel.XlSaveAsAccessMode.xlNoChange,
                    missingType, missingType, missingType, missingType, missingType);
                    oWB.Close(false, missingType, missingType);
                    //Cursor.Current = Cursors.Default;
                    //MessageBox.Show("Save Success!!!");
                    AutoClosingMessageBox.Show("Save Success", "알림", 100);
                }
                catch (Exception theException)
                {
                    String errorMessage;
                    errorMessage = "Error: ";
                    errorMessage = String.Concat(errorMessage, theException.Message);
                    errorMessage = String.Concat(errorMessage, " Line: ");
                    errorMessage = String.Concat(errorMessage, theException.Source);

                    MessageBox.Show(errorMessage, "Error");
                }
            }

        }
        public void ReadExcelData(string path)
        { // path는 Excel파일의 전체 경로입니다.
          // 예. D:\test\test.xslx
            Excel.Application excelApp = null;
            Excel.Workbook wb = null;
            Excel.Worksheet ws = null;
            try
            {
                excelApp = new Excel.Application();
                wb = excelApp.Workbooks.Open(path);
                // path 대신 문자열도 가능합니다
                // 예. Open(@"D:\test\test.xslx");
                ws = wb.Worksheets.get_Item(1) as Excel.Worksheet;
                // 첫번째 Worksheet를 선택합니다.
                Excel.Range rng = ws.UsedRange;   // '여기'
                                                  // 현재 Worksheet에서 사용된 셀 전체를 선택합니다.
                object[,] data = rng.Value;
                // 열들에 들어있는 Data를 배열 (One-based array)로 받아옵니다.
                for (int r = 1; r < data.GetLength(0); r++)
                {
                    for (int c = 1; c <= data.GetLength(1); c++)
                    {
                        if (data[r, c] == null)
                        {
                            continue;
                        }
                        //dataGridView_TableSetting.SelectedRows(r - 1).Cells(c - 1).Value = data[r + 1, c];


                        // Data 빼오기
                        // data[r, c] 는 excel의 (r, c) 셀 입니다.
                        // data.GetLength(0)은 엑셀에서 사용되는 행의 수를 가져오는 것이고,
                        // data.GetLength(1)은 엑셀에서 사용되는 열의 수를 가져오는 것입니다.
                        // GetLength와 [ r, c] 의 순서를 바꿔서 사용할 수 있습니다.
                    }
                    dataGridView_TableSetting.Rows[r - 1].Cells[1].Value = data[r + 1, 2];
                }
                wb.Close(true);
                excelApp.Quit();
            }
            catch (Exception ex)
            {
                ReleaseExcelObject(ws);
                ReleaseExcelObject(wb);
                ReleaseExcelObject(excelApp);
               // button_ExcelKill_Click(null, null);
                return;
                throw ex;
            }
            finally
            {
                ReleaseExcelObject(ws);
                ReleaseExcelObject(wb);
                ReleaseExcelObject(excelApp);
              //  button_ExcelKill_Click(null, null);
            }
        }
        private void ReleaseExcelObject(object obj)
        {
            try
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(obj);
                obj = null;
            }
            catch (Exception ex)
            {
                obj = null;
                MessageBox.Show("Unable to release the Object " + ex.ToString());
            }
            finally
            {
                GC.Collect();
            }
        }

        private void button_LengthApply_Click(object sender, EventArgs e)
        {
            
            int TempDbmData = 1;
            string tempstr = "";
            for (int i = 0; i < numericUpDown_TableLength.Value; i++)
            {
                dataGridView_TableSetting.Rows.Add();
                tempstr = string.Format("{0:0.0}", TempDbmData);
                dataGridView_TableSetting[0, i].Value = Convert.ToString(tempstr) + " dBm"; ;
                dataGridView_TableSetting[1, i].Value = "0";
                TempDbmData = TempDbmData + 1;
            }

            foreach (DataGridViewRow row in this.dataGridView_TableSetting.Rows)
            {
                row.HeaderCell.Value = String.Format("{0}", row.Index + 1);
            }
            this.dataGridView_TableSetting.AutoResizeRowHeadersWidth(
            DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders);
            this.dataGridView_TableSetting.TopLeftHeaderCell.Value = "No.";
            dataGridView_TableSetting.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView_TableSetting.ClearSelection();
        }
        private void GridView_array(ref double[] data)
        {
            int i = 0;
            data[i] = dataGridView_TableSetting.RowCount;
            for (i = 0; i < dataGridView_TableSetting.RowCount; i++)
            {
                data[i + 1] = Convert.ToDouble(dataGridView_TableSetting[1, i].Value);
            }
        }
        private void button_Dev_Save_Click(object sender, EventArgs e)
        {
            double[] temp_array = new double[dataGridView_TableSetting.RowCount + 2];
            byte[] ret_array = new byte[temp_array.Length * 2 + 10];
            Etc_Function etc_Function = new Etc_Function();
            GridView_array(ref temp_array);
            ret_array = etc_Function.NessLab_Protocol_Create(temp_array, (int)Etc_Function.NessLab_Protocol_CMD_Index.NessLab_TableSet_Req);

            ((Main)main_form).serial.Serial_DataSend(ret_array, ret_array.Length);
            ((Main)main_form).TimerIntervalCnt = 0;
        }

        private void button_Dev_Load_Click(object sender, EventArgs e)
        {
            double[] temp_array = new double[dataGridView_TableSetting.RowCount + 1];
            byte[] ret_array = new byte[temp_array.Length * 2 + 10];

            Etc_Function etc_Function = new Etc_Function();

            ret_array = etc_Function.NessLab_Protocol_Create(temp_array, (int)Etc_Function.NessLab_Protocol_CMD_Index.NessLab_Table_Req);

            ((Main)main_form).serial.Serial_DataSend(ret_array, ret_array.Length);
            ((Main)main_form).TimerIntervalCnt = 0;
        }

        private void button_Initialize_Click(object sender, EventArgs e)
        {

        }

        private void button_Expansion_Click(object sender, EventArgs e)
        {

        }

        private void button_MultiSet_Click(object sender, EventArgs e)
        {
            List<int> TmpList = new List<int>();
            TmpList = DataGridViewIndexOutput();
            for (int i = 0; i < TmpList.Count; i++)
            {
                dataGridView_TableSetting[1, TmpList[i]].Value = numericUpDown_MultiSet.Value.ToString();
            }
        }
        private List<int> DataGridViewIndexOutput()
        {
            List<int> Tmplist = new List<int>();

            Int32 selectedCellCount =
            dataGridView_TableSetting.GetCellCount(DataGridViewElementStates.Selected);
            if (selectedCellCount > 0)
            {
                System.Text.StringBuilder sb =
                    new System.Text.StringBuilder();

                //for (int i = 0;i < selectedCellCount; i++)
                for (int i = 0; i < selectedCellCount; i += 2)
                {
                    sb.Append("Row: ");
                    sb.Append(dataGridView_TableSetting.SelectedCells[i].RowIndex.ToString());
                    Tmplist.Add(dataGridView_TableSetting.SelectedCells[i].RowIndex);
                    /*sb.Append(", Column: ");
                    sb.Append(dataGridView_TableSetting.SelectedCells[i].ColumnIndex.ToString());*/
                    sb.Append(Environment.NewLine);
                }

                // sb.Append("Total: " + selectedCellCount.ToString());
                // MessageBox.Show(sb.ToString(), "Selected Cells");
            }
            return Tmplist;
        }

        public void Table_Setting(byte[] data)
        {
            //dataGridView_TableSetting.RowCount = data[(int)NessLab_Index.NessLab_DataLength];
            double ret = 0;

            for (int i = 1; i < data[(int)NessLab_Index.NessLab_DataLength] / 2 + 1; i++)
            {
                ret = (double)((data[(int)((i * 2) + (NessLab_Index.NessLab_DataLength + 1))] << 8) | data[(int)((i * 2) + NessLab_Index.NessLab_DataLength + 2)]) / 1000;
                dataGridView_TableSetting[1, i].Value = ret;
            }

        }
    }
}
